VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   BackColor       =   &H00FF9900&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "ListBox Control..."
   ClientHeight    =   3270
   ClientLeft      =   45
   ClientTop       =   210
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   4455
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton CloseBut 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2760
      Width           =   975
   End
   Begin VB.CommandButton SaveBut 
      Caption         =   "&Save List"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   2400
      Width           =   975
   End
   Begin VB.CommandButton OpenBut 
      Caption         =   "&Open List"
      Height          =   375
      Left            =   120
      TabIndex        =   10
      Top             =   2040
      Width           =   975
   End
   Begin VB.CommandButton NewBut 
      Caption         =   "&New List"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   6
      Top             =   1680
      Width           =   975
   End
   Begin MSComDlg.CommonDialog Dialog 
      Left            =   3840
      Top             =   2640
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "ListBox Control"
      Filter          =   "List File|*.lst|Data File|*.dat|Text File|*.txt|All Files|*.*"
   End
   Begin VB.CommandButton DownBut 
      Height          =   375
      Left            =   600
      Picture         =   "listbox.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   8
      Top             =   1320
      Width           =   495
   End
   Begin VB.CommandButton UpBut 
      Height          =   375
      Left            =   120
      Picture         =   "listbox.frx":03A9
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   1320
      Width           =   495
   End
   Begin VB.CommandButton RemoveBut 
      Caption         =   "&Remove"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   960
      Width           =   975
   End
   Begin VB.CommandButton AddBut 
      Caption         =   "&Add"
      Enabled         =   0   'False
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   975
   End
   Begin VB.CommandButton ClearBut 
      Caption         =   "&Clear"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3360
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
   Begin VB.ListBox ListBox 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0FFFF&
      Height          =   2565
      ItemData        =   "listbox.frx":0751
      Left            =   1200
      List            =   "listbox.frx":0753
      MousePointer    =   10  'Up Arrow
      TabIndex        =   1
      Top             =   600
      Width           =   3135
   End
   Begin VB.TextBox TextBox 
      Appearance      =   0  'Flat
      BackColor       =   &H00C0FFFF&
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim AbovePos As String
Dim SelfPos As String
Dim BelowPos As String
Dim AbovePosIndex As Integer
Dim SelfPosIndex As Integer
Dim BelowPosIndex As Integer
Dim LineText, FilePath As String
Dim Opened As Boolean
Public Function Data()
AbovePos = ListBox.List(ListBox.ListIndex - 1)
SelfPos = ListBox.List(ListBox.ListIndex)
BelowPos = ListBox.List(ListBox.ListIndex + 1)
AbovePosIndex = ListBox.ListIndex - 1
SelfPosIndex = ListBox.ListIndex
BelowPosIndex = ListBox.ListIndex + 1
End Function
Public Function MakeFalse()
    NewBut.Enabled = False
    RemoveBut.Enabled = False
    SaveBut.Enabled = False
End Function
Public Function MakeTrue()
    NewBut.Enabled = True
    RemoveBut.Enabled = True
    SaveBut.Enabled = True
End Function
Private Sub AddBut_Click()
If TextBox.Text <> "" Then
    ListBox.AddItem (TextBox.Text)
    TextBox.Text = ""
    TextBox.SetFocus
    Call MakeTrue
End If
End Sub
Private Sub ClearBut_Click()
    TextBox.Text = ""
    TextBox.SetFocus
End Sub
Private Sub NewBut_Click()
    Response = MsgBox("Create a new list?", vbQuestion + vbYesNo, "ListBox Control")
If Response = vbYes Then
    ListBox.Clear
    Call MakeFalse
    Opened = False
    FilePath = ""
End If
End Sub
Private Sub ListBox_Click()
    Call Data
End Sub
Private Sub OpenBut_Click()
    Dialog.ShowOpen
    FilePath = Dialog.FileName
    Opened = True
If FilePath <> "" Then Call LoadList(ListBox)
End Sub
Public Function LoadList(ListBoxName As ListBox)
    On Error GoTo ErrorHandler
    ListBox.Clear
    Open FilePath For Input As #1
    While Not EOF(1)
        Line Input #1, LineText
        If Trim$(LineText) <> "" Then ListBox.AddItem LineText
    Wend
    Close #1
If ListBox.ListCount >= 1 Then Call MakeTrue
AfterLoadList:
    Exit Function
ErrorHandler:
    MsgBox "An error occurred whilst adding items to the list.", vbExclamation, "ListBox Control"
    Resume AfterLoadList
End Function
Private Sub RemoveBut_Click()
    Selected = ListBox.ListIndex + 1
If ListBox.ListCount <= 1 Then
    ListBox.Clear
    Call MakeFalse
Else
    Call RemoveItem
    Items = ListBox.ListCount
    If Selected <= Items Then
        ListBox.Selected(SelfPosIndex) = True
    Else
        ListBox.Selected(AbovePosIndex) = True
    End If
End If
End Sub
Private Sub SaveBut_Click()
    Dialog.ShowSave
    FilePath = Dialog.FileName
If FilePath <> "" Then
For I = 1 To ListBox.ListCount
    Set File = CreateObject("Scripting.FileSystemObject")
    Set Make = File.CreateTextFile(FilePath, True)
    ListBox.Selected(I - 1) = True
    Make.WriteLine (ExistingData & ListBox.Text)
    Make.Close
    f = FreeFile
    Open FilePath For Input As f
    ExistingData = Input(LOF(f), f)
    Close f
Next
End If
End Sub
Private Sub TextBox_Change()
If TextBox.Text = "" Then
    ClearBut.Enabled = False
    AddBut.Enabled = False
Else
    ClearBut.Enabled = True
    AddBut.Enabled = True
End If
End Sub
Private Sub TextBox_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = 13 Then Call AddBut_Click
End Sub
Public Function RemoveItem()
If ListBox.SelCount > 0 Then
   ListBox.RemoveItem (ListBox.ListIndex)
Else
    MsgBox "Select a file then try again.", vbExclamation, "Error"
End If
End Function
Private Sub UpBut_Click()
If ListBox.ListCount >= 2 Then
    If ListBox.ListIndex >= 1 Then
        ListBox.RemoveItem (SelfPosIndex)
        ListBox.RemoveItem (AbovePosIndex)
        ListBox.AddItem SelfPos, AbovePosIndex
        ListBox.AddItem AbovePos, SelfPosIndex
    End If
End If
If ListBox.ListIndex <> 0 Then ListBox.Selected(AbovePosIndex) = True
End Sub
Private Sub DownBut_Click()
If ListBox.ListIndex + 1 <> ListBox.ListCount Then
    ListBox.RemoveItem (BelowPosIndex)
    ListBox.RemoveItem (SelfPosIndex)
    ListBox.AddItem BelowPos, SelfPosIndex
    ListBox.AddItem SelfPos, BelowPosIndex
    If ListBox.ListIndex = ListBox.ListCount Then
        ListBox.Selected(SelfPosIndex) = True
    Else
        ListBox.Selected(BelowPosIndex) = True
    End If
End If
End Sub
Private Sub CloseBut_Click()
    End
End Sub
